#include <stdio.h>
#include <stdint.h>

enum {
	// _xinfreq = 20_000_000,
	_xtlfreq = 20_000_000,
	_clkfreq = 4_000_000,

	ENCPIN = 12,
	CYCLERATE = 2,   //Hertz
};


void  main( void )
{
	uint64_t  pos64 = 0;

	_waitms(200);
	printf( "\n   clkfreq = %d   clkmode = 0x%x\n", _clockfreq(), _clockmode() );

	_pinstart( ENCPIN, P_QUADRATURE | P_PLUS2_B | P_OE | P_LOW_FLOAT | P_HIGH_1MA | P_INVERT_OUTPUT,  // SmartB = base+2
		   _clockfreq() / CYCLERATE, 0 );  // Z holds last period's delta
	_pinstart( ENCPIN+2, P_QUADRATURE | P_MINUS2_A | P_OE | P_LOW_FLOAT | P_HIGH_1MA | P_INVERT_OUTPUT,  // SmartA = base-2
		   0, 0 );  // Z holds the live counter

	while( true )
	{
		if( _pinread(ENCPIN) )
		{
			pos64 += _rdpin(ENCPIN);
			printf( " pos32 =%10d   pos64 = %lld  \r", _rdpin(ENCPIN+2), pos64 );
		}
	}
}
